#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef lint
static char rcsid[] = "$Id: ddup.c,v 2.3 1999/08/03 20:17:37 thomas Exp thomas $";
#endif


void base64(void);
unsigned char alphabet[64] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
char auth_en[100];
char auth[100];
char username[100];
char pass[100];
char *ip_address = NULL;

int main( int argc, char *argv[] ) {
   char buf_in[4000];
   char buf_out[1000];
   char *find = "Success";
   int sd;	
   
   read_config(&username, &pass);
   opt(argc, argv);
   strcat(auth, username);
   strcat(auth, ":");
   strcat(auth, pass);
  
   base64();
   chomp(auth_en);
   exit(update());
}


void base64(void)
{
    int cols, bits, c, char_count, x, y;

    char_count = 0;
    bits = 0;
    cols = 0;
    x = y = 0;
    while ((c = auth[x++]) != '\0') {
	if (c > 255) {
	    fprintf(stderr, "encountered char > 255 (decimal %d)", c);
	    exit(1);
	}
	bits += c;
	char_count++;
	if (char_count == 3) {
	    auth_en[y++] = alphabet[bits >> 18];
	    auth_en[y++] = alphabet[(bits >> 12) & 0x3f];
	    auth_en[y++] = alphabet[(bits >> 6) & 0x3f];
	    auth_en[y++] = alphabet[bits & 0x3f];
	    cols += 4;
	    if (cols == 72) {
		auth_en[y++] = '\n';
		cols = 0;
	    }
	    bits = 0;
	    char_count = 0;
	} else {
	    bits <<= 8;
	}
    }
    if (char_count != 0) {
	bits <<= 16 - (8 * char_count);
	auth_en[y++] = alphabet[bits >> 18];
	auth_en[y++] = alphabet[(bits >> 12) & 0x3f];
	if (char_count == 1) {
	    auth_en[y++] = '=';
	    auth_en[y++] = '=';
	} else {
	    auth_en[y++] = alphabet[(bits >> 6) & 0x3f];
	    auth_en[y++] = '=';
	}
	if (cols > 0)
	  auth_en[y++] = '\n';
    }
    auth_en[y++] = '\0';
}

void usage(void) {
	printf("Usage:  ddup --host host.domain.ext [--ip address] [--wildcard]\n");
	printf("        [--proxyserv server] [--proxyport port] [--help] [--debug] [--mx mxhost]\n");
	printf("        [--backmx]\n");
	printf("        --host host.domain.ext : REQUIRED to update.\n"); 
	printf("                                 Where host.domain.ext is your domain.\n"); 
	printf("                                 eg. gandy.dyndns.org, gandy.ath.cx\n");
	printf("        --ip address : Forces maunal ip specification\n");
	printf("                       Where address is you IP address.\n");
	printf("        --wildcard : Enables wildcards.\n");
	printf("	--mx mxhost : Sets your MX to mxhost.\n");
	printf("	--backmx : Needs --mx and sets mxhost to be a backup MX.\n");
	printf("        --proxyserv server : Uses server as proxy.\n");
	printf("        --proxyport port : connects to proxy with port.\n");
	printf("        --help : Prints this message.\n");
	printf("	--debug : Prints debug output of what is sent to server.\n");
	exit(0);
}
